classification
Title: Provide run_until_complete inside loop
Type: enhancement Stage: resolved
Components: asyncio Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: Nosy List: asvetlov, gvanrossum, martin.panter, txomon, yselivanov
Priority: normal Keywords:

Created on 2017-02-14 17:17 by txomon, last changed 2017-12-20 20:29 by asvetlov. This issue is now closed.

Messages (4)
msg287784 - (view) Author: Javier Domingo (txomon) Date: 2017-02-14 17:16
The current architecture of asyncio makes it really hard to combine both async and sync code.

When porting a Thread based application to asyncio, the first step is usually to start merging threads to the main loop, by using `run_coroutine_threadsafe`. This works well and allows to use a single ioloop from different threads.

There is another step, that usually involves the patching of libraries to work in an async way. One will typically patch the IO calls to be asyncio, and using `run_until_complete` proves useful in these situations.

However, at the moment it's not possible to `run_until_complete` from an ioloop. The possibility to be able to patch sync libraries to run in asyncio is something that would help a lot the migration.

This functionality would basically provide a way to continue running the ioloop until the future is resolved.

Sync code -> async code -> Sync code -> Async code

If you know how to have this without spawning an executor, that would be good too, in such case I would rather ask for documentation on how to do it =)
msg287800 - (view) Author: Martin Panter (martin.panter) * (Python committer) Date: 2017-02-14 20:54
Sounds related to Issue 22239
msg287847 - (view) Author: Javier Domingo (txomon) Date: 2017-02-15 11:47
Yes, indeed it is. Would it be possible to reconsider this functionality? It plays a key role when trying to rewrite full applications to async.

Rewriting the full stack of libraries at once is impossible, but the patching can easily be done in many cases.
msg308804 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2017-12-20 20:29
Awaiting a future from blocking code which in turn is executed from async code is very dangerous idea -- it will block other async code execution.

The feature will be never implemented as well as nested loops, sorry.

Closing.
History
Date User Action Args
2017-12-20 20:29:27asvetlovsetstatus: open -> closed

nosy: + asvetlov
messages: + msg308804

resolution: wont fix
stage: resolved
2017-02-15 11:47:00txomonsetmessages: + msg287847
2017-02-14 20:54:24martin.pantersetnosy: + martin.panter
messages: + msg287800
2017-02-14 17:17:00txomoncreate